package  
{
	import flash.display.BitmapData;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.utils.Input;
	import net.flashpunk.World;
	
	public class Level extends World 
	{
		public var sunA:Sun;
		public var sunB:Sun;		
		public var planetA1:Planet;
		public var planetA2:Planet; 
		public var planetA3:Planet;
		public var planetB1:Planet;
		public var planetB2:Planet;
		public var planetB3:Planet;
		
		public var bg:BG;
		public var win:Boolean = false;
		
		public var shake:int = 0;
		
		public var start:Boolean = false;
		
		private var drawHealth1:Number = 100;
		private var drawHealth2:Number = 100;
		
		private var flashColor:uint;
		private var flashAlpha:Number = 0;

		public function Level() 
		{
			FP.screen.scale = 1;
		}
		
		override public function begin():void 
		{
			super.begin();
			
			add(bg = new BG);
			
			var bd:BitmapData = new BitmapData(800, 600, true, 0);
			for (var i:int = 0; i < 100; i++)
				bd.setPixel32(FP.rand(800), FP.rand(600), 0xFFFFFFFF);
			addGraphic(new Image(bd));
			
			addGraphic(Main.particles);
			
			add(new Title);
			
			sunA = new Sun(120, Main.MID_Y, 0);
			add(sunA);
			
			sunB = new Sun(680, Main.MID_Y, 1);
			add(sunB);
			
			var p1:int = FP.choose(50, -50);
			var p2:int = FP.choose(120, -120);
			var p3:int = FP.choose(200, -200);
			
			planetA1 = new Planet(120 + p1, Main.MID_Y, sunA, sunB, 0xFFFF00, Planet.ImgA, Planet.ImgAShadow);
			planetA2 = new Planet(120 + p2, Main.MID_Y, sunA, sunB, 0xFFFF00, Planet.ImgA, Planet.ImgAShadow);
			planetA3 = new Planet(120 + p3, Main.MID_Y, sunA, sunB, 0xFFFF00, Planet.ImgA, Planet.ImgAShadow);
			planetB1 = new Planet(680 - p1, Main.MID_Y, sunB, sunA, 0x00FFFF, Planet.ImgA, Planet.ImgAShadow);
			planetB2 = new Planet(680 - p2, Main.MID_Y, sunB, sunA, 0x00FFFF, Planet.ImgA, Planet.ImgAShadow);
			planetB3 = new Planet(680 - p3, Main.MID_Y, sunB, sunA, 0x00FFFF, Planet.ImgA, Planet.ImgAShadow);
			
			add(planetA1);
			add(planetA2);
			add(planetA3);
			add(planetB1);
			add(planetB2);
			add(planetB3);
		}
		
		override public function render():void 
		{
			super.render();
			
			drawHealth1 = FP.lerp(drawHealth1, sunA.health, 0.1);
			drawHealth2 = FP.lerp(drawHealth2, sunB.health, 0.1);
			
			if (Math.abs(drawHealth1 - sunA.health) <= .01)
				drawHealth1 = sunA.health;
			if (Math.abs(drawHealth2 - sunB.health) <= .01)
				drawHealth2 = sunB.health;
			
			//p1
			if (drawHealth1 != sunA.health)
			{
				FP.point.x = -3 + FP.rand(6);
				FP.point.y = -3 + FP.rand(6);
			}
			else
				FP.point.x = FP.point.y = 0;
			Draw.rect(25 + FP.point.x, 25 + FP.point.y, 200, 20, 0x888800);
			if (sunA.health > 0)
				Draw.rect(25 + FP.point.x, 25 + FP.point.y, drawHealth1 * 2, 20, 0xFFFF00);		
			if (Main.wins1 > 0)
				Draw.text(Main.wins1Str, 240, 21, { align:"left", font:"title", size:24, color:0xFFFF00 } );
			
			//p2
			if (drawHealth2 != sunB.health)
			{
				FP.point.x = -3 + FP.rand(6);
				FP.point.y = -3 + FP.rand(6);
			}
			else
				FP.point.x = FP.point.y = 0;
			Draw.rect(575 + FP.point.x, 25 + FP.point.y, 200, 20, 0x008888);
			if (sunB.health > 0)
				Draw.rect(775 - drawHealth2 * 2 + FP.point.x, 25 + FP.point.y, sunB.health * 2, 20, 0x00FFFF);
			if (Main.wins2 > 0)
				Draw.text(Main.wins2Str, 543, 21, { align:"right", font:"title", size:24, color:0x00FFFF } );
				
			if (flashAlpha > 0)
			{
				Draw.rect(-6, -6, 812, 612, flashColor, flashAlpha);
				flashAlpha -= .05;
			}
		}
		
		override public function update():void 
		{
			super.update();
			
			if (shake > 0)
			{
				shake--;
				FP.camera.x = FP.choose(-3, -2, 2, 3);
				FP.camera.y = FP.choose(-3, -2, 2, 3);
			}
			else
			{
				FP.camera.x = FP.camera.y = 0;
			}
		}
		
		public function screenFlash(color:uint):void
		{
			flashAlpha = 1;
			flashColor = color;
		}
		
	}

}