package 
{
	import net.flashpunk.*;
	import net.flashpunk.graphics.Emitter;
	import net.flashpunk.utils.Ease;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;

	[Frame(factoryClass="Preloader")]
	public class Main extends Engine 
	{
		[Embed(source = "../assets/particles.png")]
		static private const ImgPart:Class;
		
		[Embed(source = "../assets/sfx/audio.swf", symbol = "dingding.wav")]
		static private const SNDDingDing:Class;
		static public const SndDingDing:Sfx = new Sfx(SNDDingDing);
		[Embed(source = "../assets/sfx/audio.swf", symbol = "Explode.wav")]
		static private const SNDExplode:Class;
		static public const SndExplode:Sfx = new Sfx(SNDExplode);
		[Embed(source = "../assets/sfx/audio.swf", symbol = "PlanetHit.wav")]
		static private const SNDPlanetHit:Class;
		static public const SndPlanetHit:Sfx = new Sfx(SNDPlanetHit);
		[Embed(source = "../assets/sfx/audio.swf", symbol = "StrongHit.wav")]
		static private const SNDStrongHit:Class;
		static public const SndStrongHit:Sfx = new Sfx(SNDStrongHit);
		[Embed(source = "../assets/sfx/audio.swf", symbol = "WeakHit.wav")]
		static private const SNDWeakHit:Class;
		static public const SndWeakHit:Sfx = new Sfx(SNDWeakHit);
		[Embed(source = "../assets/sfx/audio.swf", symbol = "Kill.wav")]
		static private const SNDKill:Class;
		static public const SndKill:Sfx = new Sfx(SNDKill);
		[Embed(source = "../assets/sfx/audio.swf", symbol = "Select.wav")]
		static private const SNDSelect:Class;
		static public const SndSelect:Sfx = new Sfx(SNDSelect);
		[Embed(source = "../assets/sfx/audio.swf", symbol = "Fight.wav")]
		static private const SNDFight:Class;
		static public const SndFight:Sfx = new Sfx(SNDFight);
		[Embed(source = "../assets/sfx/audio.swf", symbol = "Knockout.wav")]
		static private const SNDKnockout:Class;
		static public const SndKnockout:Sfx = new Sfx(SNDKnockout);
		[Embed(source = "../assets/sfx/audio.swf", symbol = "Trophy.wav")]
		static private const SNDTrophy:Class;
		static public const SndTrophy:Sfx = new Sfx(SNDTrophy);
		[Embed(source = "../assets/sfx/audio.swf", symbol = "RaRa.wav")]
		static private const MUSRaRa:Class;
		static public const MusRaRa:Sfx = new Sfx(MUSRaRa);
		
		static public const MID_X:int = 400;
		static public const MID_Y:int = 300;
		static public const GRAVITY:Number = 0.1;
		
		static public var particles:Emitter;
		
		static public var wins1:int = 0;
		static public var wins2:int = 0;
		
		static public var wins1Str:String = "";
		static public var wins2Str:String = "";

		public function Main():void 
		{
			super(800, 600, 60, true);
			FP.screen.originX = 400;
			FP.screen.originY = 300;
			
			Input.define("p1left", Key.A);
			Input.define("p1right", Key.D);
			Input.define("p1up", Key.W);
			Input.define("p1down", Key.S);
			
			Input.define("p2left", Key.LEFT);
			Input.define("p2right", Key.RIGHT);
			Input.define("p2up", Key.UP);
			Input.define("p2down", Key.DOWN);
			
			Input.define("start", Key.ENTER);
			
			particles = new Emitter(ImgPart, 16, 16);
			
			particles.newType("p1lava", [0, 1, 2, 3])
				.setColor(0xFFFF00, 0xFFFF00)
				.setAlpha(1, 0, Ease.cubeIn);
				
			particles.newType("p2lava", [0, 1, 2, 3])
				.setColor(0x00FFFF, 0x00FFFF)
				.setAlpha(1, 0, Ease.cubeIn);
				
			particles.newType("p1explode", [4, 5, 4, 5, 4, 5, 4, 5, 4, 5])
				.setMotion(0, 10, 60, 360, 5, 10)
				.setColor(0xFFFF00, 0xFFFF00)
				.setAlpha(1, 0, Ease.cubeIn);
				
			particles.newType("p2explode", [4, 5, 4, 5, 4, 5, 4, 5, 4, 5])
				.setMotion(0, 10, 60, 360, 5, 10)
				.setColor(0x00FFFF, 0x00FFFF)
				.setAlpha(1, 0, Ease.cubeIn);
				
			particles.newType("p1explodeB", [4, 5, 4, 5, 4, 5, 4, 5, 4, 5])
				.setMotion(0, 130, 60, 360, 35, 10)
				.setColor(0xFFFF00, 0xFFFF00)
				.setAlpha(1, 0, Ease.cubeIn);
				
			particles.newType("p2explodeB", [4, 5, 4, 5, 4, 5, 4, 5, 4, 5])
				.setMotion(0, 130, 60, 360, 35, 10)
				.setColor(0x00FFFF, 0x00FFFF)
				.setAlpha(1, 0, Ease.cubeIn);

			MusRaRa.loop(1.2);
				
			FP.world = new Level();
		}

	}

}