package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.utils.Input;
	
	public class Title extends Entity
	{
		[Embed(source = "../assets/grapple.ttf", embedAsCFF="false", fontFamily = 'title')]
		static public const Font:Class;
		
		var titleA:Text;
		var titleB:Text;
		var desc:Text;
		var p1:Text;
		var p2:Text;
		var start:Text;
		var author:Text;
		
		public function Title() 
		{
			layer = -1000;
			
			addGraphic(titleA = new Text("RA", 350, 150, { color:0x00FFFF, size:72, font:"title" } ));
			titleA.centerOrigin();
			
			addGraphic(titleB = new Text("RA", 450, 150, { color:0xFFFF00, size:72, font:"title" } ));
			titleB.centerOrigin();
			
			addGraphic(desc = new Text("extreme star boxing", 400, 200, { color: 0xFF0000, size:24, font:"title" }));
			desc.centerOrigin();
			
			addGraphic(p1 = new Text("P1 use WASD", 200, 400, { color: 0xFFFF00, size:32, font:"title" }));
			p1.centerOrigin();
			
			addGraphic(p2 = new Text("P2 use Arrows", 600, 400, { color: 0x00FFFF, size:32, font:"title" }));
			p2.centerOrigin();
			
			addGraphic(start = new Text("ENTER to start", 400, 500, { color: 0xFF0000, size:48, font:"title" }));
			start.centerOrigin();
			
			addGraphic(author = new Text("by Maddy Thorson    www.maddymakesgames.com", 400, 590, { color: 0xFFFFFF, size:16 } ));
			author.centerOrigin();
		}
		
		override public function update():void 
		{
			super.update();
			
			if (Input.pressed("start"))
			{
				Main.SndDingDing.play(3);
				world.remove(this);
				world.add(new Fight);
			}
		}
		
		override public function render():void 
		{
			Draw.rect(0, 0, 800, 600, 0, 0.3);
			Draw.rect(0, 100, 800, 130, 0, 0.5);
			
			titleA.angle = -10 + FP.random * 20;
			titleB.angle = -10 + FP.random * 20;
			
			desc.x = 396 + FP.random * 8;
			desc.y = 196 + FP.random * 8;
			
			p1.x = 196 + FP.random * 8;
			p1.y = 396 + FP.random * 8;
			
			p2.x = 596 + FP.random * 8;
			p2.y = 396 + FP.random * 8;
			
			start.x = 396 + FP.random * 8;
			start.y = 496 + FP.random * 8;
			
			super.render();
		}
		
	}

}